ASN1Object Class Referenceabstract

Interface for encoding and decoding ASN1 objects. More...

`#include <cryptlib.h>`

Inheritance diagram for ASN1Object:

## Public Member Functions

virtual void | BERDecode (BufferedTransformation &bt)=0
| Decode this object from a BufferedTransformation.
virtual void | DEREncode (BufferedTransformation &bt) const =0
| Encode this object into a BufferedTransformation.
virtual void | BEREncode (BufferedTransformation &bt) const
| Encode this object into a BufferedTransformation.

## Detailed Description

Interface for encoding and decoding ASN1 objects.

Each class that derives from ASN1Object should provide a serialization format that controls subobject layout. Most of the time the serialization format is taken from a standard, like P1363 or an RFC.

Definition at line 3288 of file cryptlib.h.

## Constructor & Destructor Documentation

## ~ASN1Object()

virtual ASN1Object::~ASN1Object | ( |  | ) |

inline virtual

Definition at line 3291 of file cryptlib.h.

## Member Function Documentation

## BERDecode()

virtual void ASN1Object::BERDecode | ( | BufferedTransformation & | bt | ) |

pure virtual

Decode this object from a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER)

Implemented in DL_GroupParameters_IntegerBased, ed25519PrivateKey, ed25519PublicKey, ESIGNFunction, Integer, InvertibleESIGNFunction, InvertibleRSAFunction, PKCS8PrivateKey, x25519, and X509PublicKey.

## DEREncode()

virtual void ASN1Object::DEREncode | ( | BufferedTransformation & | bt | ) | const

pure virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Distinguished Encoding Rules (DER)

Implemented in DL_GroupParameters_IntegerBased, ed25519PrivateKey, ed25519PublicKey, ESIGNFunction, Integer, InvertibleESIGNFunction, InvertibleRSAFunction, PKCS8PrivateKey, x25519, and X509PublicKey.

## BEREncode()

virtual void ASN1Object::BEREncode | ( | BufferedTransformation & | bt | ) | const

inline virtual

Encode this object into a BufferedTransformation.

Parameters

  bt | BufferedTransformation object

Uses Basic Encoding Rules (BER).

This may be useful if DEREncode() would be too inefficient.

Definition at line 3307 of file cryptlib.h.

The documentation for this class was generated from the following file:

- cryptlib.h